Codeforces Round #Pi (Div. 2) C. Geometric Progression dp

来源:互联网 发布:网络语gg是什么意思 编辑:程序博客网 时间:2024/05/22 02:37
C. Geometric Progression
time limit per test
1 second
memory limit per test
256 megabytes
input
standard input
output
standard output

Polycarp loves geometric progressions very much. Since he was only three years old, he loves only the progressions of length three. He also has a favorite integer k and a sequence a, consisting of n integers.

He wants to know how many subsequences of length three can be selected from a, so that they form a geometric progression with common ratio k.

A subsequence of length three is a combination of three such indexes i1, i2, i3, that 1 ≤ i1 < i2 < i3 ≤ n. That is, a subsequence of length three are such groups of three elements that are not necessarily consecutive in the sequence, but their indexes are strictly increasing.

A geometric progression with common ratio k is a sequence of numbers of the form b·k0, b·k1, ..., b·kr - 1.

Polycarp is only three years old, so he can not calculate this number himself. Help him to do it.

Input

The first line of the input contains two integers, n and k (1 ≤ n, k ≤ 2·105), showing how many numbers Polycarp's sequence has and his favorite number.

The second line contains n integers a1, a2, ..., an ( - 109 ≤ ai ≤ 109) — elements of the sequence.

Output

Output a single number — the number of ways to choose a subsequence of length three, such that it forms a geometric progression with a common ratio k.

Sample test(s)
input
5 21 1 2 2 4
output
4
input
3 11 1 1
output
1
input
10 31 2 6 2 3 6 9 18 3 9
output
6
Note

In the first sample test the answer is four, as any of the two 1s can be chosen as the first element, the second element can be any of the 2s, and the third element of the subsequence must be equal to 4.

题意要求,给定一个数列,要求所有子序列(顺序一定),长度为3的等比数列的个数。

设dp[i][4] 表示,值为i,已经形成1 2 3长度的序列的个数

则dp[i][1] = dp[i][1] +  1;

dp[i][2] = dp[i][2] +  dp[j][1];

dp[i][3] = dp[i][2] +  dp[j][2];(j * k = i);

由于i很大,所以用map存,复杂度为n * log(n) 注意要long long

<pre name="code" class="cpp">#define N 1000005#define M 1000005#define maxn 205#define MOD 1000000000000000007int n,pri[N],k;struct node{    ll num[4];};map<int,node> mymap;map<int,node>::iterator it;int main(){    while(S2(n,k)!=EOF)    {        mymap.clear();        FI(n) S(pri[i]);        FI(n){            int t = pri[i] / k;            if(pri[i] % k == 0 && mymap.count(t)){                node no =  mymap[t];                node tn;                if(mymap.count(pri[i])){                    tn = mymap[pri[i]];                }                else {                    tn.num[1] =  0;                    tn.num[2] =  0;                    tn.num[3] =  0;                }                tn.num[2] +=  no.num[1];                tn.num[3] +=  no.num[2];                mymap[pri[i]] = tn;            }            if(!mymap.count(pri[i]))            {                node no ;                no.num[1] = 1;no.num[2] = 0;no.num[3] = 0;                mymap[pri[i]] = no;            }            else {                node tn = mymap[pri[i]];                tn.num[1]++;                mymap[pri[i]] = tn;            }        }        ll ans = 0;        for(it = mymap.begin();it != mymap.end();it++){            node no = it->second;            ans += (ll)no.num[3];        }        cout<<ans<<endl;    }    return 0;}



0 0